<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: PRD_OrdenCab.xml */
/* Generado: 2021-04-06 20:52:06 */

/* Mantenimiento de los registros de la tabla PRD_OrdenCab */
abstract class BasePRD_OrdenCabDP extends PRD_OrdenCabBV
{
    /* Constructor ( Establece los valores desde un objeto PRD_OrdenCabBN ) */
    public function __construct( PRD_OrdenCabBN $o_PRD_OrdenCabBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_PRD_OrdenCabBN ) )
        {
            $this->setByBN( $o_PRD_OrdenCabBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto PRD_OrdenCabBN */
    public function setByBN( PRD_OrdenCabBN $o_PRD_OrdenCabBN )
    {
        if ( !is_null( $o_PRD_OrdenCabBN->getIdOrdenCab() ) )
        {
            $this->setIdOrdenCab( $o_PRD_OrdenCabBN->getIdOrdenCab() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_PRD_OrdenCabBN->getIdCompania() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_PRD_OrdenCabBN->getIdSucursal() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getFechaOrden() ) )
        {
            $this->setFechaOrden( $o_PRD_OrdenCabBN->getFechaOrden() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getTipoOrden() ) )
        {
            $this->setTipoOrden( $o_PRD_OrdenCabBN->getTipoOrden() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_PRD_OrdenCabBN->getIdAlmacen() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdProyecto() ) )
        {
            $this->setIdProyecto( $o_PRD_OrdenCabBN->getIdProyecto() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getProyectoDesc() ) )
        {
            $this->setProyectoDesc( $o_PRD_OrdenCabBN->getProyectoDesc() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getProFinalId() ) )
        {
            $this->setProFinalId( $o_PRD_OrdenCabBN->getProFinalId() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdDocRef() ) )
        {
            $this->setIdDocRef( $o_PRD_OrdenCabBN->getIdDocRef() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getDocNumRef() ) )
        {
            $this->setDocNumRef( $o_PRD_OrdenCabBN->getDocNumRef() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdAlmacenRef() ) )
        {
            $this->setIdAlmacenRef( $o_PRD_OrdenCabBN->getIdAlmacenRef() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getComentario() ) )
        {
            $this->setComentario( $o_PRD_OrdenCabBN->getComentario() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getEstado() ) )
        {
            $this->setEstado( $o_PRD_OrdenCabBN->getEstado() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdTipoDocumentoSal() ) )
        {
            $this->setIdTipoDocumentoSal( $o_PRD_OrdenCabBN->getIdTipoDocumentoSal() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdNumeroDocumentoSal() ) )
        {
            $this->setIdNumeroDocumentoSal( $o_PRD_OrdenCabBN->getIdNumeroDocumentoSal() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdTransaccionSal() ) )
        {
            $this->setIdTransaccionSal( $o_PRD_OrdenCabBN->getIdTransaccionSal() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdTipoDocumentoIng() ) )
        {
            $this->setIdTipoDocumentoIng( $o_PRD_OrdenCabBN->getIdTipoDocumentoIng() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdNumeroDocumentoIng() ) )
        {
            $this->setIdNumeroDocumentoIng( $o_PRD_OrdenCabBN->getIdNumeroDocumentoIng() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdTransaccionIng() ) )
        {
            $this->setIdTransaccionIng( $o_PRD_OrdenCabBN->getIdTransaccionIng() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdTipoDocumentoTrf() ) )
        {
            $this->setIdTipoDocumentoTrf( $o_PRD_OrdenCabBN->getIdTipoDocumentoTrf() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdNumeroDocumentoTrf() ) )
        {
            $this->setIdNumeroDocumentoTrf( $o_PRD_OrdenCabBN->getIdNumeroDocumentoTrf() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getIdTransaccionTrf() ) )
        {
            $this->setIdTransaccionTrf( $o_PRD_OrdenCabBN->getIdTransaccionTrf() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_PRD_OrdenCabBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_PRD_OrdenCabBN->getFechaCreacion() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_PRD_OrdenCabBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_PRD_OrdenCabBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_PRD_OrdenCabBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_PRD_OrdenCabFN = new PRD_OrdenCabFN();
        $o_PRD_OrdenCabBN = $o_PRD_OrdenCabFN->selectByPk( $this->getIdOrdenCab() );
        if ( is_null( $o_PRD_OrdenCabBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO PRD_OrdenCab ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdOrdenCab() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdOrdenCab";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdOrdenCab()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaOrden() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaOrden";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaOrden()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoOrden() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoOrden";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoOrden()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdProyecto";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProyectoDesc() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ProyectoDesc";
                $s_SQLQuery2 .= $s_Separator."'".$this->getProyectoDesc()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProFinalId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ProFinalId";
                $s_SQLQuery2 .= $s_Separator."".$this->getProFinalId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdDocRef() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdDocRef";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdDocRef()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocNumRef() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DocNumRef";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDocNumRef()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacenRef() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacenRef";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacenRef()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Comentario";
                $s_SQLQuery2 .= $s_Separator."'".$this->getComentario()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumentoSal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoDocumentoSal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipoDocumentoSal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumentoSal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdNumeroDocumentoSal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdNumeroDocumentoSal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccionSal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTransaccionSal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTransaccionSal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumentoIng() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoDocumentoIng";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipoDocumentoIng()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumentoIng() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdNumeroDocumentoIng";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdNumeroDocumentoIng()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccionIng() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTransaccionIng";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTransaccionIng()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumentoTrf() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoDocumentoTrf";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipoDocumentoTrf()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumentoTrf() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdNumeroDocumentoTrf";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdNumeroDocumentoTrf()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccionTrf() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTransaccionTrf";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTransaccionTrf()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE PRD_OrdenCab SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaOrden() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaOrden = '".$this->getFechaOrden()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoOrden() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoOrden = '".$this->getTipoOrden()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacen = '".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery .= $s_Separator."IdProyecto = ".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProyectoDesc() ) )
            {
                $s_SQLQuery .= $s_Separator."ProyectoDesc = '".$this->getProyectoDesc()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProFinalId() ) )
            {
                $s_SQLQuery .= $s_Separator."ProFinalId = ".$this->getProFinalId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdDocRef() ) )
            {
                $s_SQLQuery .= $s_Separator."IdDocRef = ".$this->getIdDocRef()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocNumRef() ) )
            {
                $s_SQLQuery .= $s_Separator."DocNumRef = '".$this->getDocNumRef()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacenRef() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacenRef = '".$this->getIdAlmacenRef()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentario() ) )
            {
                $s_SQLQuery .= $s_Separator."Comentario = '".$this->getComentario()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumentoSal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoDocumentoSal = '".$this->getIdTipoDocumentoSal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumentoSal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdNumeroDocumentoSal = '".$this->getIdNumeroDocumentoSal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccionSal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTransaccionSal = '".$this->getIdTransaccionSal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumentoIng() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoDocumentoIng = '".$this->getIdTipoDocumentoIng()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumentoIng() ) )
            {
                $s_SQLQuery .= $s_Separator."IdNumeroDocumentoIng = '".$this->getIdNumeroDocumentoIng()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccionIng() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTransaccionIng = '".$this->getIdTransaccionIng()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumentoTrf() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoDocumentoTrf = '".$this->getIdTipoDocumentoTrf()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumentoTrf() ) )
            {
                $s_SQLQuery .= $s_Separator."IdNumeroDocumentoTrf = '".$this->getIdNumeroDocumentoTrf()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccionTrf() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTransaccionTrf = '".$this->getIdTransaccionTrf()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdOrdenCab = ".$this->getIdOrdenCab().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM PRD_OrdenCab WHERE  IdOrdenCab = ".$this->getIdOrdenCab().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>